!===================================================
! DO NOT EDIT THIS FILE, it was generated using ../../../../tools/cprnc/genf90/genf90.pl 
! Any changes you make to this file may be lost
!===================================================
module pio
  ! This module provides a stub implementation of a subset of PIO.
  !
  ! This can be used when you need the PIO interfaces in order for your unit tests to
  ! build, but do not actually need to make use of any of the PIO functionality in your
  ! unit tests.

  ! Note that not all PIO functionality is stubbed here. Stubs are written on an
  ! as-needed basis, and others can be added here as needed.

  ! Note about organization: variables, functions/subroutines, etc. should be kept in
  ! alphabetical order to facilitate finding what you want. Currently, this is roughly
  ! true, though is violated for specific routines within a group (e.g., implementations
  ! of the initdecomp interface).

  ! NOTE(wjs, 2015-01-12) In some routines here, variables that are declared as
  ! intent(out) in the real code are declared intent(inout) here. I am using intent(inout)
  ! because I do not want to bother with assigning a value to these, and some compilers
  ! complain if you don't assign a value to an intent(out) argument.


!  uses mpi if available
#ifndef NO_MPIMOD
   use mpi, only : MPI_OFFSET_KIND ! _EXTERNAL
#endif
  
  implicit none
  private

#ifdef NO_MPIMOD
   include 'mpif.h'   ! _EXTERNAL
#endif
  
  type, public :: file_desc_t
  end type file_desc_t

  type, public :: io_desc_t
  end type io_desc_t
  
  type, public :: iosystem_desc_t
  end type iosystem_desc_t
  
  type, public :: var_desc_t
  end type var_desc_t

  integer, parameter, private ::          &
       i4        = selected_int_kind(6)   ,&
       i8        = selected_int_kind(13)  ,&
       r4        = selected_real_kind(6)  ,&
       r8        = selected_real_kind(13)

  integer, parameter, public :: PIO_64BIT_OFFSET = 0
  integer(i4), parameter, public :: PIO_BCAST_ERROR = 0
  integer, parameter, public :: PIO_CLOBBER = 0
  integer, parameter, public :: PIO_DOUBLE = 0
  integer, parameter, public :: PIO_GLOBAL = 0
  integer, parameter, public :: PIO_INT = 0
  integer(i4), parameter, public :: PIO_INTERNAL_ERROR = 0
  integer, parameter, public :: PIO_iotype_netcdf = 0
  integer, parameter, public :: PIO_iotype_netcdf4c = 0
  integer, parameter, public :: PIO_iotype_netcdf4p = 0
  integer, parameter, public :: PIO_iotype_pnetcdf = 0
  integer, parameter, public :: PIO_NOWRITE = 0
  integer, parameter, public :: pio_offset = MPI_OFFSET_KIND
  integer, parameter, public :: pio_offset_kind = pio_offset
  integer, parameter, public :: pio_rearr_subset = 0
  integer, parameter, public :: PIO_WRITE = 0

  public :: PIO_def_dim
  public :: PIO_enddef
  public :: PIO_FILE_IS_OPEN
  public :: pio_inq_dimid
  public :: pio_inq_dimlen
  public :: pio_set_blocksize
  
  public :: PIO_closefile
# 77 "pio.F90.in"
  interface PIO_closefile
     module procedure closefile
  end interface PIO_closefile

  public :: PIO_createfile
# 82 "pio.F90.in"
  interface PIO_createfile
     module procedure createfile
  end interface

  public :: pio_def_var
# 87 "pio.F90.in"
  interface pio_def_var
     module procedure &
          def_var_0d, &
          def_var_md
  end interface

  public :: PIO_finalize
# 94 "pio.F90.in"
  interface PIO_finalize
     module procedure finalize
  end interface

  public :: PIO_freedecomp
# 99 "pio.F90.in"
  interface PIO_freedecomp
     module procedure freedecomp_ios
     module procedure freedecomp_file
  end interface
  
  public :: pio_get_att
# 105 "pio.F90.in"
  interface pio_get_att
     module procedure get_att_text, get_att_desc_text
     module procedure get_att_real, get_att_desc_real
     module procedure get_att_double, get_att_desc_double
     module procedure get_att_int, get_att_desc_int
     ! TYPE real,int,double
     module procedure get_att_1d_real, get_att_desc_1d_real
     ! TYPE real,int,double
     module procedure get_att_1d_int, get_att_desc_1d_int
     ! TYPE real,int,double
     module procedure get_att_1d_double, get_att_desc_1d_double
  end interface
  
  public :: pio_get_var
# 112 "pio.F90.in"
  interface pio_get_var
     module procedure get_var_0d_text, get_var_vdesc_0d_text
     module procedure get_var_1d_text, get_var_vdesc_1d_text
     module procedure get_var_2d_text, get_var_vdesc_2d_text
     module procedure get_var_3d_text, get_var_vdesc_3d_text
     module procedure get_var_4d_text, get_var_vdesc_4d_text
     module procedure get_var_5d_text, get_var_vdesc_5d_text
     module procedure get_var_0d_real, get_var_vdesc_0d_real
     module procedure get_var_1d_real, get_var_vdesc_1d_real
     module procedure get_var_2d_real, get_var_vdesc_2d_real
     module procedure get_var_3d_real, get_var_vdesc_3d_real
     module procedure get_var_4d_real, get_var_vdesc_4d_real
     module procedure get_var_5d_real, get_var_vdesc_5d_real
     module procedure get_var_0d_double, get_var_vdesc_0d_double
     module procedure get_var_1d_double, get_var_vdesc_1d_double
     module procedure get_var_2d_double, get_var_vdesc_2d_double
     module procedure get_var_3d_double, get_var_vdesc_3d_double
     module procedure get_var_4d_double, get_var_vdesc_4d_double
     module procedure get_var_5d_double, get_var_vdesc_5d_double
     module procedure get_var_0d_int, get_var_vdesc_0d_int
     module procedure get_var_1d_int, get_var_vdesc_1d_int
     module procedure get_var_2d_int, get_var_vdesc_2d_int
     module procedure get_var_3d_int, get_var_vdesc_3d_int
     module procedure get_var_4d_int, get_var_vdesc_4d_int
     module procedure get_var_5d_int, get_var_vdesc_5d_int
     !  DIMS 1,2,3,4,5
     module procedure get_vara_1d_text, get_vara_vdesc_1d_text
     !  DIMS 1,2,3,4,5
     module procedure get_vara_2d_text, get_vara_vdesc_2d_text
     !  DIMS 1,2,3,4,5
     module procedure get_vara_3d_text, get_vara_vdesc_3d_text
     !  DIMS 1,2,3,4,5
     module procedure get_vara_4d_text, get_vara_vdesc_4d_text
     !  DIMS 1,2,3,4,5
     module procedure get_vara_5d_text, get_vara_vdesc_5d_text
     !  DIMS 1,2,3,4,5
     module procedure get_vara_1d_real, get_vara_vdesc_1d_real
     !  DIMS 1,2,3,4,5
     module procedure get_vara_2d_real, get_vara_vdesc_2d_real
     !  DIMS 1,2,3,4,5
     module procedure get_vara_3d_real, get_vara_vdesc_3d_real
     !  DIMS 1,2,3,4,5
     module procedure get_vara_4d_real, get_vara_vdesc_4d_real
     !  DIMS 1,2,3,4,5
     module procedure get_vara_5d_real, get_vara_vdesc_5d_real
     !  DIMS 1,2,3,4,5
     module procedure get_vara_1d_double, get_vara_vdesc_1d_double
     !  DIMS 1,2,3,4,5
     module procedure get_vara_2d_double, get_vara_vdesc_2d_double
     !  DIMS 1,2,3,4,5
     module procedure get_vara_3d_double, get_vara_vdesc_3d_double
     !  DIMS 1,2,3,4,5
     module procedure get_vara_4d_double, get_vara_vdesc_4d_double
     !  DIMS 1,2,3,4,5
     module procedure get_vara_5d_double, get_vara_vdesc_5d_double
     !  DIMS 1,2,3,4,5
     module procedure get_vara_1d_int, get_vara_vdesc_1d_int
     !  DIMS 1,2,3,4,5
     module procedure get_vara_2d_int, get_vara_vdesc_2d_int
     !  DIMS 1,2,3,4,5
     module procedure get_vara_3d_int, get_vara_vdesc_3d_int
     !  DIMS 1,2,3,4,5
     module procedure get_vara_4d_int, get_vara_vdesc_4d_int
     !  DIMS 1,2,3,4,5
     module procedure get_vara_5d_int, get_vara_vdesc_5d_int
     module procedure get_var1_text, get_var1_vdesc_text
     module procedure get_var1_real, get_var1_vdesc_real
     module procedure get_var1_double, get_var1_vdesc_double
     module procedure get_var1_int, get_var1_vdesc_int
  end interface

  public :: PIO_init
# 120 "pio.F90.in"
  interface PIO_init
     module procedure init_intracom
     module procedure init_intercom
  end interface

  public :: PIO_initdecomp
# 126 "pio.F90.in"
  interface PIO_initdecomp
     module procedure PIO_initdecomp_dof_i4  ! previous name: initdecomop_1dof_nf_box
     module procedure PIO_initdecomp_dof_i8  ! previous name: initdecomop_1dof_nf_box
     module procedure PIO_initdecomp_dof_i8_vdc 
     module procedure initdecomp_1dof_nf_i4
     module procedure initdecomp_1dof_nf_i8
     module procedure initdecomp_1dof_bin_i4
     module procedure initdecomp_1dof_bin_i8
     module procedure initdecomp_2dof_nf_i4
     module procedure initdecomp_2dof_nf_i8
     module procedure initdecomp_2dof_bin_i4
     module procedure initdecomp_2dof_bin_i8
     module procedure PIO_initdecomp_bc
     module procedure PIO_initdecomp_dof_dof
  end interface
  
  public :: pio_inq_varid
# 143 "pio.F90.in"
  interface pio_inq_varid
     module procedure inq_varid_vid, &
          inq_varid_vardesc
  end interface pio_inq_varid

  public :: PIO_openfile
# 149 "pio.F90.in"
  interface PIO_openfile
     module procedure PIO_openfile
  end interface

  public :: PIO_put_att
# 154 "pio.F90.in"
  interface PIO_put_att
     module procedure put_att_text, put_att_desc_text
     module procedure put_att_real, put_att_desc_real
     module procedure put_att_double, put_att_desc_double
     module procedure put_att_int, put_att_desc_int
     ! TYPE real,int,double
     module procedure put_att_1d_real, put_att_desc_1d_real
     ! TYPE real,int,double
     module procedure put_att_1d_int, put_att_desc_1d_int
     ! TYPE real,int,double
     module procedure put_att_1d_double, put_att_desc_1d_double
  end interface

  public :: pio_put_var
# 161 "pio.F90.in"
  interface pio_put_var
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_0d_text, put_var_vdesc_0d_text
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_1d_text, put_var_vdesc_1d_text
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_2d_text, put_var_vdesc_2d_text
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_3d_text, put_var_vdesc_3d_text
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_4d_text, put_var_vdesc_4d_text
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_5d_text, put_var_vdesc_5d_text
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_0d_real, put_var_vdesc_0d_real
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_1d_real, put_var_vdesc_1d_real
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_2d_real, put_var_vdesc_2d_real
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_3d_real, put_var_vdesc_3d_real
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_4d_real, put_var_vdesc_4d_real
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_5d_real, put_var_vdesc_5d_real
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_0d_double, put_var_vdesc_0d_double
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_1d_double, put_var_vdesc_1d_double
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_2d_double, put_var_vdesc_2d_double
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_3d_double, put_var_vdesc_3d_double
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_4d_double, put_var_vdesc_4d_double
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_5d_double, put_var_vdesc_5d_double
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_0d_int, put_var_vdesc_0d_int
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_1d_int, put_var_vdesc_1d_int
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_2d_int, put_var_vdesc_2d_int
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_3d_int, put_var_vdesc_3d_int
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_4d_int, put_var_vdesc_4d_int
     !  DIMS 0,1,2,3,4,5
     module procedure put_var_5d_int, put_var_vdesc_5d_int
     !  DIMS 1,2,3,4,5
     module procedure put_vara_1d_text, put_vara_vdesc_1d_text
     !  DIMS 1,2,3,4,5
     module procedure put_vara_2d_text, put_vara_vdesc_2d_text
     !  DIMS 1,2,3,4,5
     module procedure put_vara_3d_text, put_vara_vdesc_3d_text
     !  DIMS 1,2,3,4,5
     module procedure put_vara_4d_text, put_vara_vdesc_4d_text
     !  DIMS 1,2,3,4,5
     module procedure put_vara_5d_text, put_vara_vdesc_5d_text
     !  DIMS 1,2,3,4,5
     module procedure put_vara_1d_real, put_vara_vdesc_1d_real
     !  DIMS 1,2,3,4,5
     module procedure put_vara_2d_real, put_vara_vdesc_2d_real
     !  DIMS 1,2,3,4,5
     module procedure put_vara_3d_real, put_vara_vdesc_3d_real
     !  DIMS 1,2,3,4,5
     module procedure put_vara_4d_real, put_vara_vdesc_4d_real
     !  DIMS 1,2,3,4,5
     module procedure put_vara_5d_real, put_vara_vdesc_5d_real
     !  DIMS 1,2,3,4,5
     module procedure put_vara_1d_double, put_vara_vdesc_1d_double
     !  DIMS 1,2,3,4,5
     module procedure put_vara_2d_double, put_vara_vdesc_2d_double
     !  DIMS 1,2,3,4,5
     module procedure put_vara_3d_double, put_vara_vdesc_3d_double
     !  DIMS 1,2,3,4,5
     module procedure put_vara_4d_double, put_vara_vdesc_4d_double
     !  DIMS 1,2,3,4,5
     module procedure put_vara_5d_double, put_vara_vdesc_5d_double
     !  DIMS 1,2,3,4,5
     module procedure put_vara_1d_int, put_vara_vdesc_1d_int
     !  DIMS 1,2,3,4,5
     module procedure put_vara_2d_int, put_vara_vdesc_2d_int
     !  DIMS 1,2,3,4,5
     module procedure put_vara_3d_int, put_vara_vdesc_3d_int
     !  DIMS 1,2,3,4,5
     module procedure put_vara_4d_int, put_vara_vdesc_4d_int
     !  DIMS 1,2,3,4,5
     module procedure put_vara_5d_int, put_vara_vdesc_5d_int
     module procedure put_var1_text, put_var1_vdesc_text
     module procedure put_var1_real, put_var1_vdesc_real
     module procedure put_var1_double, put_var1_vdesc_double
     module procedure put_var1_int, put_var1_vdesc_int
  end interface

  public :: PIO_read_darray
# 170 "pio.F90.in"
  interface PIO_read_darray
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_1d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_2d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_3d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_4d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_5d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_6d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_7d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_1d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_2d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_3d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_4d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_5d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_6d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_7d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_1d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_2d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_3d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_4d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_5d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_6d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure read_darray_7d_double
  end interface

  public :: pio_set_buffer_size_limit
# 177 "pio.F90.in"
  interface pio_set_buffer_size_limit
    module procedure pio_set_buffer_size_limit_i4
    module procedure pio_set_buffer_size_limit_i8
  end interface

  public :: PIO_setdebuglevel
# 183 "pio.F90.in"
  interface PIO_setdebuglevel
     module procedure setdebuglevel
  end interface PIO_setdebuglevel
  
  public :: PIO_seterrorhandling
# 188 "pio.F90.in"
  interface PIO_seterrorhandling
     module procedure seterrorhandlingf
     module procedure seterrorhandlingi
  end interface
  
  public :: PIO_write_darray
# 194 "pio.F90.in"
  interface PIO_write_darray
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_1d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_2d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_3d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_4d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_5d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_6d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_7d_real
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_1d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_2d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_3d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_4d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_5d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_6d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_7d_int
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_1d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_2d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_3d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_4d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_5d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_6d_double
! TYPE real,int,double
! DIMS 1,2,3,4,5,6,7
     module procedure write_darray_7d_double
  end interface
  
# 200 "pio.F90.in"
contains

# 202 "pio.F90.in"
  subroutine closefile(file)
    type (file_desc_t),intent(inout)   :: file
# 204 "pio.F90.in"
  end subroutine closefile

# 206 "pio.F90.in"
  integer function createfile(iosystem, file,iotype, fname, amode_in) result(ierr)
    type (iosystem_desc_t), intent(inout), target :: iosystem
    type (file_desc_t), intent(inout) :: file
    integer, intent(in) :: iotype
    character(len=*), intent(in)  :: fname
    integer, optional, intent(in) :: amode_in

    ierr = 0
# 214 "pio.F90.in"
  end function createfile

# 216 "pio.F90.in"
  integer function def_var_0d(File,name,type,vardesc) result(ierr)

    type (File_desc_t), intent(in)  :: File
    character(len=*), intent(in)    :: name
    integer, intent(in)             :: type
    type (Var_desc_t), intent(inout) :: vardesc

    ierr = 0
# 224 "pio.F90.in"
  end function def_var_0d

# 226 "pio.F90.in"
  integer function def_var_md(File,name,type,dimids,vardesc) result(ierr)
    type (File_desc_t), intent(in)  :: File
    character(len=*), intent(in)    :: name
    integer, intent(in)             :: type
    integer, intent(in)             :: dimids(:)
    type (Var_desc_t), intent(inout) :: vardesc

    ierr = 0
# 234 "pio.F90.in"
  end function def_var_md

# 236 "pio.F90.in"
  subroutine finalize(iosystem,ierr)
     type (iosystem_desc_t), intent(inout) :: iosystem 
     integer(i4), intent(out) :: ierr

     ierr = 0
# 241 "pio.F90.in"
   end subroutine finalize
     
# 243 "pio.F90.in"
  subroutine freedecomp_ios(ios,iodesc)
    type (iosystem_desc_t) :: ios
    type (io_desc_t) :: iodesc
# 246 "pio.F90.in"
  end subroutine freedecomp_ios

# 248 "pio.F90.in"
  subroutine freedecomp_file(file,iodesc)
    type (file_desc_t) :: file
    type (io_desc_t) :: iodesc
# 251 "pio.F90.in"
  end subroutine freedecomp_file
    
# 253 "pio.F90.in"
  integer function get_att_desc_text (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    character(len=*), intent(inout)      :: value

    ierr = 0
# 260 "pio.F90.in"
  end function get_att_desc_text
# 253 "pio.F90.in"
  integer function get_att_desc_real (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    real(r4), intent(inout)      :: value

    ierr = 0
# 260 "pio.F90.in"
  end function get_att_desc_real
# 253 "pio.F90.in"
  integer function get_att_desc_double (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    real(r8), intent(inout)      :: value

    ierr = 0
# 260 "pio.F90.in"
  end function get_att_desc_double
# 253 "pio.F90.in"
  integer function get_att_desc_int (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    integer(i4), intent(inout)      :: value

    ierr = 0
# 260 "pio.F90.in"
  end function get_att_desc_int

! TYPE real,int,double
# 263 "pio.F90.in"
  integer function get_att_desc_1d_real (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    real(r4), intent(inout)      :: value(:)

    ierr = 0
# 270 "pio.F90.in"
  end function get_att_desc_1d_real
! TYPE real,int,double
# 263 "pio.F90.in"
  integer function get_att_desc_1d_int (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    integer(i4), intent(inout)      :: value(:)

    ierr = 0
# 270 "pio.F90.in"
  end function get_att_desc_1d_int
! TYPE real,int,double
# 263 "pio.F90.in"
  integer function get_att_desc_1d_double (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    real(r8), intent(inout)      :: value(:)

    ierr = 0
# 270 "pio.F90.in"
  end function get_att_desc_1d_double

# 272 "pio.F90.in"
  integer function get_att_text (File,varid,name,value) result(ierr)
    type (File_desc_t), intent(in) , target :: File
    integer(i4), intent(in)        :: varid
    character(len=*), intent(in)   :: name
    character(len=*), intent(inout)          :: value

    ierr = 0
# 279 "pio.F90.in"
  end function get_att_text
# 272 "pio.F90.in"
  integer function get_att_real (File,varid,name,value) result(ierr)
    type (File_desc_t), intent(in) , target :: File
    integer(i4), intent(in)        :: varid
    character(len=*), intent(in)   :: name
    real(r4), intent(inout)          :: value

    ierr = 0
# 279 "pio.F90.in"
  end function get_att_real
# 272 "pio.F90.in"
  integer function get_att_double (File,varid,name,value) result(ierr)
    type (File_desc_t), intent(in) , target :: File
    integer(i4), intent(in)        :: varid
    character(len=*), intent(in)   :: name
    real(r8), intent(inout)          :: value

    ierr = 0
# 279 "pio.F90.in"
  end function get_att_double
# 272 "pio.F90.in"
  integer function get_att_int (File,varid,name,value) result(ierr)
    type (File_desc_t), intent(in) , target :: File
    integer(i4), intent(in)        :: varid
    character(len=*), intent(in)   :: name
    integer(i4), intent(inout)          :: value

    ierr = 0
# 279 "pio.F90.in"
  end function get_att_int

! TYPE real,int,double
# 282 "pio.F90.in"
  integer function get_att_1d_real (File,varid,name,value) result(ierr)
    type (File_desc_t), intent(in) , target :: File
    integer(i4), intent(in)        :: varid
    character(len=*), intent(in)   :: name
    real(r4), intent(inout)          :: value(:)

    ierr = 0
# 289 "pio.F90.in"
  end function get_att_1d_real
! TYPE real,int,double
# 282 "pio.F90.in"
  integer function get_att_1d_int (File,varid,name,value) result(ierr)
    type (File_desc_t), intent(in) , target :: File
    integer(i4), intent(in)        :: varid
    character(len=*), intent(in)   :: name
    integer(i4), intent(inout)          :: value(:)

    ierr = 0
# 289 "pio.F90.in"
  end function get_att_1d_int
! TYPE real,int,double
# 282 "pio.F90.in"
  integer function get_att_1d_double (File,varid,name,value) result(ierr)
    type (File_desc_t), intent(in) , target :: File
    integer(i4), intent(in)        :: varid
    character(len=*), intent(in)   :: name
    real(r8), intent(inout)          :: value(:)

    ierr = 0
# 289 "pio.F90.in"
  end function get_att_1d_double
    
# 291 "pio.F90.in"
  integer function get_var1_text (File,varid, index, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, index(:)
    character(len=*), intent(inout) :: ival

    ierr = 0
# 297 "pio.F90.in"
  end function get_var1_text
# 291 "pio.F90.in"
  integer function get_var1_real (File,varid, index, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, index(:)
    real(r4), intent(inout) :: ival

    ierr = 0
# 297 "pio.F90.in"
  end function get_var1_real
# 291 "pio.F90.in"
  integer function get_var1_double (File,varid, index, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, index(:)
    real(r8), intent(inout) :: ival

    ierr = 0
# 297 "pio.F90.in"
  end function get_var1_double
# 291 "pio.F90.in"
  integer function get_var1_int (File,varid, index, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, index(:)
    integer(i4), intent(inout) :: ival

    ierr = 0
# 297 "pio.F90.in"
  end function get_var1_int

# 299 "pio.F90.in"
  integer function get_var1_vdesc_text (File,vardesc, index, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: index(:)
    character(len=*), intent(inout) :: ival

    ierr = 0
# 306 "pio.F90.in"
  end function get_var1_vdesc_text
# 299 "pio.F90.in"
  integer function get_var1_vdesc_real (File,vardesc, index, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: index(:)
    real(r4), intent(inout) :: ival

    ierr = 0
# 306 "pio.F90.in"
  end function get_var1_vdesc_real
# 299 "pio.F90.in"
  integer function get_var1_vdesc_double (File,vardesc, index, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: index(:)
    real(r8), intent(inout) :: ival

    ierr = 0
# 306 "pio.F90.in"
  end function get_var1_vdesc_double
# 299 "pio.F90.in"
  integer function get_var1_vdesc_int (File,vardesc, index, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: index(:)
    integer(i4), intent(inout) :: ival

    ierr = 0
# 306 "pio.F90.in"
  end function get_var1_vdesc_int

! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_1d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(inout) :: ival(:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_1d_text
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_2d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(inout) :: ival(:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_2d_text
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_3d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(inout) :: ival(:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_3d_text
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_4d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_4d_text
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_5d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_5d_text
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_1d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(inout) :: ival(:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_1d_real
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_2d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(inout) :: ival(:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_2d_real
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_3d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(inout) :: ival(:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_3d_real
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_4d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_4d_real
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_5d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_5d_real
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_1d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(inout) :: ival(:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_1d_double
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_2d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(inout) :: ival(:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_2d_double
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_3d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(inout) :: ival(:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_3d_double
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_4d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_4d_double
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_5d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_5d_double
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_1d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(inout) :: ival(:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_1d_int
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_2d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(inout) :: ival(:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_2d_int
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_3d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(inout) :: ival(:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_3d_int
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_4d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_4d_int
! DIMS 1,2,3,4,5
# 309 "pio.F90.in"
  integer function get_vara_5d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 315 "pio.F90.in"
  end function get_vara_5d_int

! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_1d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    character(len=*), intent(inout) :: ival(:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_1d_text
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_2d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    character(len=*), intent(inout) :: ival(:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_2d_text
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_3d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    character(len=*), intent(inout) :: ival(:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_3d_text
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_4d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    character(len=*), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_4d_text
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_5d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    character(len=*), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_5d_text
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_1d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r4), intent(inout) :: ival(:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_1d_real
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_2d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r4), intent(inout) :: ival(:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_2d_real
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_3d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r4), intent(inout) :: ival(:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_3d_real
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_4d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r4), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_4d_real
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_5d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r4), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_5d_real
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_1d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r8), intent(inout) :: ival(:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_1d_double
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_2d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r8), intent(inout) :: ival(:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_2d_double
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_3d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r8), intent(inout) :: ival(:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_3d_double
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_4d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r8), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_4d_double
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_5d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    real(r8), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_5d_double
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_1d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    integer(i4), intent(inout) :: ival(:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_1d_int
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_2d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    integer(i4), intent(inout) :: ival(:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_2d_int
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_3d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    integer(i4), intent(inout) :: ival(:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_3d_int
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_4d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    integer(i4), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_4d_int
! DIMS 1,2,3,4,5
# 318 "pio.F90.in"
  integer function get_vara_vdesc_5d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) :: start(:), count(:)
    integer(i4), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 325 "pio.F90.in"
  end function get_vara_vdesc_5d_int

# 327 "pio.F90.in"
  integer function get_var_0d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    character(len=*), intent(inout) :: ival

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_0d_text
# 327 "pio.F90.in"
  integer function get_var_1d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    character(len=*), intent(inout) :: ival(:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_1d_text
# 327 "pio.F90.in"
  integer function get_var_2d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    character(len=*), intent(inout) :: ival(:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_2d_text
# 327 "pio.F90.in"
  integer function get_var_3d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    character(len=*), intent(inout) :: ival(:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_3d_text
# 327 "pio.F90.in"
  integer function get_var_4d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    character(len=*), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_4d_text
# 327 "pio.F90.in"
  integer function get_var_5d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    character(len=*), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_5d_text
# 327 "pio.F90.in"
  integer function get_var_0d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r4), intent(inout) :: ival

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_0d_real
# 327 "pio.F90.in"
  integer function get_var_1d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r4), intent(inout) :: ival(:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_1d_real
# 327 "pio.F90.in"
  integer function get_var_2d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r4), intent(inout) :: ival(:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_2d_real
# 327 "pio.F90.in"
  integer function get_var_3d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r4), intent(inout) :: ival(:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_3d_real
# 327 "pio.F90.in"
  integer function get_var_4d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r4), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_4d_real
# 327 "pio.F90.in"
  integer function get_var_5d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r4), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_5d_real
# 327 "pio.F90.in"
  integer function get_var_0d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r8), intent(inout) :: ival

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_0d_double
# 327 "pio.F90.in"
  integer function get_var_1d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r8), intent(inout) :: ival(:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_1d_double
# 327 "pio.F90.in"
  integer function get_var_2d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r8), intent(inout) :: ival(:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_2d_double
# 327 "pio.F90.in"
  integer function get_var_3d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r8), intent(inout) :: ival(:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_3d_double
# 327 "pio.F90.in"
  integer function get_var_4d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r8), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_4d_double
# 327 "pio.F90.in"
  integer function get_var_5d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    real(r8), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_5d_double
# 327 "pio.F90.in"
  integer function get_var_0d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    integer(i4), intent(inout) :: ival

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_0d_int
# 327 "pio.F90.in"
  integer function get_var_1d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    integer(i4), intent(inout) :: ival(:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_1d_int
# 327 "pio.F90.in"
  integer function get_var_2d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    integer(i4), intent(inout) :: ival(:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_2d_int
# 327 "pio.F90.in"
  integer function get_var_3d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    integer(i4), intent(inout) :: ival(:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_3d_int
# 327 "pio.F90.in"
  integer function get_var_4d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    integer(i4), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_4d_int
# 327 "pio.F90.in"
  integer function get_var_5d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    integer, intent(in) :: varid
    integer(i4), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 333 "pio.F90.in"
  end function get_var_5d_int

# 335 "pio.F90.in"
  integer function get_var_vdesc_0d_text (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    character(len=*), intent(inout) :: ival

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_0d_text
# 335 "pio.F90.in"
  integer function get_var_vdesc_1d_text (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    character(len=*), intent(inout) :: ival(:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_1d_text
# 335 "pio.F90.in"
  integer function get_var_vdesc_2d_text (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    character(len=*), intent(inout) :: ival(:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_2d_text
# 335 "pio.F90.in"
  integer function get_var_vdesc_3d_text (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    character(len=*), intent(inout) :: ival(:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_3d_text
# 335 "pio.F90.in"
  integer function get_var_vdesc_4d_text (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    character(len=*), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_4d_text
# 335 "pio.F90.in"
  integer function get_var_vdesc_5d_text (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    character(len=*), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_5d_text
# 335 "pio.F90.in"
  integer function get_var_vdesc_0d_real (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r4), intent(inout) :: ival

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_0d_real
# 335 "pio.F90.in"
  integer function get_var_vdesc_1d_real (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r4), intent(inout) :: ival(:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_1d_real
# 335 "pio.F90.in"
  integer function get_var_vdesc_2d_real (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r4), intent(inout) :: ival(:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_2d_real
# 335 "pio.F90.in"
  integer function get_var_vdesc_3d_real (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r4), intent(inout) :: ival(:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_3d_real
# 335 "pio.F90.in"
  integer function get_var_vdesc_4d_real (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r4), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_4d_real
# 335 "pio.F90.in"
  integer function get_var_vdesc_5d_real (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r4), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_5d_real
# 335 "pio.F90.in"
  integer function get_var_vdesc_0d_double (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r8), intent(inout) :: ival

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_0d_double
# 335 "pio.F90.in"
  integer function get_var_vdesc_1d_double (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r8), intent(inout) :: ival(:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_1d_double
# 335 "pio.F90.in"
  integer function get_var_vdesc_2d_double (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r8), intent(inout) :: ival(:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_2d_double
# 335 "pio.F90.in"
  integer function get_var_vdesc_3d_double (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r8), intent(inout) :: ival(:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_3d_double
# 335 "pio.F90.in"
  integer function get_var_vdesc_4d_double (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r8), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_4d_double
# 335 "pio.F90.in"
  integer function get_var_vdesc_5d_double (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    real(r8), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_5d_double
# 335 "pio.F90.in"
  integer function get_var_vdesc_0d_int (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer(i4), intent(inout) :: ival

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_0d_int
# 335 "pio.F90.in"
  integer function get_var_vdesc_1d_int (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer(i4), intent(inout) :: ival(:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_1d_int
# 335 "pio.F90.in"
  integer function get_var_vdesc_2d_int (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer(i4), intent(inout) :: ival(:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_2d_int
# 335 "pio.F90.in"
  integer function get_var_vdesc_3d_int (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer(i4), intent(inout) :: ival(:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_3d_int
# 335 "pio.F90.in"
  integer function get_var_vdesc_4d_int (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer(i4), intent(inout) :: ival(:,:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_4d_int
# 335 "pio.F90.in"
  integer function get_var_vdesc_5d_int (File,vardesc, ival) result(ierr)
    type (File_desc_t), intent(in) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer(i4), intent(inout) :: ival(:,:,:,:,:)

    ierr = 0
# 341 "pio.F90.in"
  end function get_var_vdesc_5d_int

# 343 "pio.F90.in"
  subroutine init_intracom(comp_rank, comp_comm, num_iotasks, num_aggregator, stride,  rearr, iosystem,base)
    integer(i4), intent(in) :: comp_rank
    integer(i4), intent(in) :: comp_comm
    integer(i4), intent(in) :: num_iotasks 
    integer(i4), intent(in) :: num_aggregator
    integer(i4), intent(in) :: stride
    integer(i4), intent(in) :: rearr
    type (iosystem_desc_t), intent(inout)  :: iosystem  ! io descriptor to initalize

    integer(i4), intent(in),optional :: base
# 353 "pio.F90.in"
  end subroutine init_intracom

# 355 "pio.F90.in"
  subroutine init_intercom(component_count, peer_comm, comp_comms, io_comm, iosystem)
    integer, intent(in) :: component_count
    integer, intent(in) :: peer_comm
    integer, intent(in) :: comp_comms(component_count)   !  The compute communicator
    integer, intent(in) :: io_comm     !  The io communicator

    type (iosystem_desc_t), intent(inout)  :: iosystem(component_count)  ! io descriptor to initalize
# 362 "pio.F90.in"
  end subroutine init_intercom

# 364 "pio.F90.in"
  subroutine PIO_initdecomp_bc(iosystem,basepiotype,dims,compstart,compcount,iodesc,iostart,iocount)
    type (iosystem_desc_t), intent(inout) :: iosystem
    integer(i4), intent(in)               :: basepiotype
    integer(i4), intent(in)               :: dims(:)
    integer (kind=PIO_OFFSET)             :: compstart(:)  
    integer (kind=PIO_OFFSET)             :: compcount(:)    
    type (IO_desc_t), intent(inout)         :: iodesc
    integer (kind=PIO_OFFSET),optional    :: iostart(:)  
    integer (kind=PIO_OFFSET),optional    :: iocount(:)    
# 373 "pio.F90.in"
  end subroutine PIO_initdecomp_bc

# 375 "pio.F90.in"
  subroutine PIO_initdecomp_dof_dof(iosystem,basepiotype,dims,compdof,iodesc,iodof)
    type (iosystem_desc_t), intent(inout)          :: iosystem
    integer(i4), intent(in)                        :: basepiotype
    integer(i4), intent(in)                        :: dims(:)
    integer(i4), intent(in)                        :: compdof(:)
    type (IO_desc_t), intent(inout)                   :: iodesc
    integer(i4), intent(in)                        :: iodof(:)
# 382 "pio.F90.in"
  end subroutine PIO_initdecomp_dof_dof
    
# 384 "pio.F90.in"
  subroutine initdecomp_2dof_bin_i4(iosystem,basepiotype,dims,lenblocks,compdof,iodofr,iodofw,iodesc)
    type (iosystem_desc_t), intent(in) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)           :: dims(:)
    integer (i4), intent(in)          :: lenblocks
    integer (i4), intent(in)          :: compdof(:)   !> global degrees of freedom for computational decomposition
    integer (i4), intent(in)          :: iodofr(:)     !> global degrees of freedom for io decomposition 
    integer (i4), intent(in)          :: iodofw(:)     !> global degrees of freedom for io decomposition 
    type (io_desc_t), intent(inout)     :: iodesc
# 393 "pio.F90.in"
  end subroutine initdecomp_2dof_bin_i4

# 395 "pio.F90.in"
  subroutine initdecomp_2dof_bin_i8(iosystem,basepiotype,dims,lenblocks,compdof,iodofr,iodofw,iodesc)
    type (iosystem_desc_t), intent(in) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)           :: dims(:)
    integer (i4), intent(in)          :: lenblocks
    integer (kind=pio_offset), intent(in)          :: compdof(:)   !> global degrees of freedom for computational decomposition
    integer (kind=pio_offset), intent(in)          :: iodofr(:)     !> global degrees of freedom for io decomposition 
    integer (kind=pio_offset), intent(in)          :: iodofw(:)     !> global degrees of freedom for io decomposition 
    type (io_desc_t), intent(inout)     :: iodesc
# 404 "pio.F90.in"
  end subroutine initdecomp_2dof_bin_i8

# 406 "pio.F90.in"
  subroutine initdecomp_1dof_bin_i8(iosystem,basepiotype,dims,lenblocks,compdof,iodofr,iodesc)
    type (iosystem_desc_t), intent(in) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)           :: dims(:)
    integer(i4), intent(in)          :: lenblocks
    integer(kind=pio_offset), intent(in)          :: compdof(:)   ! global degrees of freedom for computational decomposition
    integer(kind=pio_offset), intent(in)          :: iodofr(:)     ! global degrees of freedom for io decomposition 
    type (io_desc_t), intent(inout)     :: iodesc
# 414 "pio.F90.in"
  end subroutine initdecomp_1dof_bin_i8

# 416 "pio.F90.in"
  subroutine initdecomp_1dof_bin_i4(iosystem,basepiotype,dims,lenblocks,compdof,iodofr,iodesc)
    type (iosystem_desc_t), intent(in) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)           :: dims(:)
    integer (i4), intent(in)          :: lenblocks
    integer (i4), intent(in)          :: compdof(:)   ! global degrees of freedom for computational decomposition
    integer (i4), intent(in)          :: iodofr(:)     ! global degrees of freedom for io decomposition 
    type (io_desc_t), intent(inout)     :: iodesc
# 424 "pio.F90.in"
  end subroutine initdecomp_1dof_bin_i4

# 426 "pio.F90.in"
  subroutine initdecomp_2dof_nf_i4(iosystem,basepiotype,dims,lenblocks,compdof,iodofr,iodofw,start, count, iodesc)
    type (iosystem_desc_t), intent(in) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)           :: dims(:)
    integer (i4), intent(in)          :: lenblocks
    integer (i4), intent(in)          :: compdof(:)   ! global degrees of freedom for computational decomposition
    integer (i4), intent(in)          :: iodofr(:)     ! global degrees of freedom for io decomposition 
    integer (i4), intent(in)          :: iodofw(:)     ! global degrees of freedom for io decomposition 

    type (io_desc_t), intent(inout)     :: iodesc

    integer(kind=PIO_offset), intent(in) :: start(:), count(:)
# 438 "pio.F90.in"
  end subroutine initdecomp_2dof_nf_i4

# 440 "pio.F90.in"
  subroutine initdecomp_2dof_nf_i8(iosystem,basepiotype,dims,lenblocks,compdof,iodofr,iodofw,start, count, iodesc)
    type (iosystem_desc_t), intent(in) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)           :: dims(:)
    integer (i4), intent(in)          :: lenblocks
    integer (kind=pio_offset), intent(in)          :: compdof(:)   ! global degrees of freedom for computational decomposition
    integer (kind=pio_offset), intent(in)          :: iodofr(:)     ! global degrees of freedom for io decomposition 
    integer (kind=pio_offset), intent(in)          :: iodofw(:)     ! global degrees of freedom for io decomposition 

    type (io_desc_t), intent(inout)     :: iodesc

    integer(kind=PIO_offset), intent(in) :: start(:), count(:)
# 452 "pio.F90.in"
  end subroutine initdecomp_2dof_nf_i8

# 454 "pio.F90.in"
  subroutine initdecomp_1dof_nf_i4(iosystem,basepiotype,dims,lenblocks,compdof,iodof,start, count, iodesc)
    type (iosystem_desc_t), intent(in) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)           :: dims(:)
    integer (i4), intent(in) :: lenblocks
    integer (i4), intent(in)          :: compdof(:)   ! global degrees of freedom for computational decomposition
    integer (i4), intent(in)          :: iodof(:)     ! global degrees of freedom for io decomposition 
    type (io_desc_t), intent(inout)     :: iodesc
    integer :: piotype	
    integer(kind=PIO_offset), intent(in) :: start(:), count(:)
# 464 "pio.F90.in"
  end subroutine initdecomp_1dof_nf_i4

# 466 "pio.F90.in"
  subroutine initdecomp_1dof_nf_i8(iosystem,basepiotype,dims,lenblocks,compdof,iodof,start, count, iodesc)
    type (iosystem_desc_t), intent(in) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)           :: dims(:)
    integer (i4), intent(in) :: lenblocks
    integer (kind=pio_offset), intent(in)          :: compdof(:)   ! global degrees of freedom for computational decomposition
    integer (kind=pio_offset), intent(in)          :: iodof(:)     ! global degrees of freedom for io decomposition 
    type (io_desc_t), intent(inout)     :: iodesc
    integer :: piotype
    integer(kind=PIO_offset), intent(in) :: start(:), count(:)
# 476 "pio.F90.in"
  end subroutine initdecomp_1dof_nf_i8

# 478 "pio.F90.in"
  subroutine PIO_initdecomp_dof_i4(iosystem,basepiotype,dims,compdof, iodesc, iostart, iocount, num_ts, bsize, rearr)
    type (iosystem_desc_t), intent(inout) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)          :: compdof(:)   ! global degrees of freedom for computational decomposition
    integer (kind=PIO_offset), optional :: iostart(:), iocount(:)
    type (io_desc_t), intent(inout)     :: iodesc
    integer(i4), intent(in)           :: dims(:)
    integer, intent(in), optional :: rearr
    !vdf optionals
    integer(i4), intent(in), optional:: num_ts, bsize(3)
# 488 "pio.F90.in"
  end subroutine PIO_initdecomp_dof_i4

# 490 "pio.F90.in"
  subroutine PIO_initdecomp_dof_i8(iosystem,basepiotype,dims,compdof, iodesc, iostart, iocount, rearr)
    type (iosystem_desc_t), intent(inout) :: iosystem
    integer(i4), intent(in)           :: basepiotype
    integer(i4), intent(in)           :: dims(:)
    integer (kind=pio_offset), intent(in)          :: compdof(:)   ! global degrees of freedom for computational decomposition
    integer (kind=PIO_offset), optional :: iostart(:), iocount(:)
    type (io_desc_t), intent(inout)     :: iodesc
    integer, intent(in), optional :: rearr
# 498 "pio.F90.in"
  end subroutine PIO_initdecomp_dof_i8

# 500 "pio.F90.in"
  subroutine PIO_initdecomp_dof_i8_vdc(iosystem,dims,compdof, iodesc, num_ts, bsize)
    type (iosystem_desc_t), intent(inout) :: iosystem
    integer(i4), intent(in)           :: dims(:)
    integer (kind=pio_offset), intent(in)          :: compdof(:)   ! global degrees of freedom for computational decomposition

    type (io_desc_t), intent(inout)     :: iodesc
    !vdc args
    integer(i4), intent(in) :: num_ts
    integer(i4), intent(in), optional:: bsize(3)
# 509 "pio.F90.in"
  end subroutine PIO_initdecomp_dof_i8_vdc
    
# 511 "pio.F90.in"
  integer function inq_varid_vardesc(File,name,vardesc) result(ierr)
      
    type (File_desc_t), intent(in)   :: File
    character(len=*), intent(in)     :: name
    type (Var_desc_t), intent(inout) :: vardesc

    ierr = 0
# 518 "pio.F90.in"
  end function inq_varid_vardesc
    
# 520 "pio.F90.in"
  integer function inq_varid_vid(File,name,varid) result(ierr)

    type (File_desc_t), intent(in)   :: File
    character(len=*), intent(in)     :: name
    integer(i4), intent(out)       :: varid

    varid = 0
    ierr = 0
# 528 "pio.F90.in"
  end function inq_varid_vid

  
# 531 "pio.F90.in"
  integer function PIO_def_dim(File,name,len,dimid) result(ierr)

    type (File_desc_t), intent(in)  :: File
    character(len=*), intent(in)    :: name
    integer(i4), intent(in)         :: len
    integer(i4), intent(out)        :: dimid

    dimid = 0
    ierr = 0
# 540 "pio.F90.in"
  end function PIO_def_dim

# 542 "pio.F90.in"
  integer function PIO_enddef(File) result(ierr)
    type (File_desc_t), intent(inout) :: File

    ierr = 0
# 546 "pio.F90.in"
  end function PIO_enddef

# 548 "pio.F90.in"
  logical function PIO_FILE_IS_OPEN(File)
    type(file_desc_t), intent(in) :: file

    PIO_FILE_IS_OPEN = .false.
# 552 "pio.F90.in"
  end function PIO_FILE_IS_OPEN
    
# 554 "pio.F90.in"
  integer function pio_inq_dimid(File,name,dimid) result(ierr)
    
    type (File_desc_t), intent(in) :: File
    character(len=*), intent(in)   :: name
    integer, intent(out)           :: dimid        !dimension ID

    dimid = 0
    ierr = 0
# 562 "pio.F90.in"
  end function pio_inq_dimid
  
# 564 "pio.F90.in"
  integer function pio_inq_dimlen(File,dimid,dimlen) result(ierr)
    
    type (File_desc_t), intent(in) :: File
    integer(i4)     , intent(in)   :: dimid
    integer(i4)     , intent(out)  :: dimlen        !dimension name

    dimlen = 0
    ierr = 0
# 572 "pio.F90.in"
  end function pio_inq_dimlen

# 574 "pio.F90.in"
  integer function PIO_openfile(iosystem, file, iotype, fname,mode, CheckMPI) result(ierr)
    type (iosystem_desc_t), intent(inout), target :: iosystem
    type (file_desc_t), intent(out) :: file
    integer, intent(in) :: iotype
    character(len=*), intent(in)  :: fname
    integer, optional, intent(in) :: mode
    logical, optional, intent(in) :: CheckMPI

    ierr = 0
# 583 "pio.F90.in"
  end function PIO_openfile

# 585 "pio.F90.in"
  subroutine pio_set_blocksize(newsize)
    integer, intent(in) :: newsize
# 587 "pio.F90.in"
  end subroutine pio_set_blocksize

# 589 "pio.F90.in"
  subroutine pio_set_buffer_size_limit_i4(limit)
    integer, intent(in) :: limit
# 591 "pio.F90.in"
  end subroutine pio_set_buffer_size_limit_i4

# 593 "pio.F90.in"
  subroutine pio_set_buffer_size_limit_i8(limit)
    integer(pio_offset), intent(in) :: limit 
# 595 "pio.F90.in"
  end subroutine pio_set_buffer_size_limit_i8
    
# 597 "pio.F90.in"
  integer function put_att_text (File, varid, name, value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: value

    ierr = 0
# 604 "pio.F90.in"
  end function put_att_text
# 597 "pio.F90.in"
  integer function put_att_real (File, varid, name, value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: name
    real(r4), intent(in) :: value

    ierr = 0
# 604 "pio.F90.in"
  end function put_att_real
# 597 "pio.F90.in"
  integer function put_att_double (File, varid, name, value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: name
    real(r8), intent(in) :: value

    ierr = 0
# 604 "pio.F90.in"
  end function put_att_double
# 597 "pio.F90.in"
  integer function put_att_int (File, varid, name, value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: name
    integer(i4), intent(in) :: value

    ierr = 0
# 604 "pio.F90.in"
  end function put_att_int

! TYPE real,double,int
# 607 "pio.F90.in"
  integer function put_att_1d_real (File, varid, name, value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: name
    real(r4), intent(in) :: value(:)

    ierr = 0
# 614 "pio.F90.in"
  end function put_att_1d_real
! TYPE real,double,int
# 607 "pio.F90.in"
  integer function put_att_1d_double (File, varid, name, value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: name
    real(r8), intent(in) :: value(:)

    ierr = 0
# 614 "pio.F90.in"
  end function put_att_1d_double
! TYPE real,double,int
# 607 "pio.F90.in"
  integer function put_att_1d_int (File, varid, name, value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: name
    integer(i4), intent(in) :: value(:)

    ierr = 0
# 614 "pio.F90.in"
  end function put_att_1d_int

# 616 "pio.F90.in"
  integer function put_att_desc_text (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    character(len=*), intent(in)      :: value

    ierr = 0
# 623 "pio.F90.in"
  end function put_att_desc_text
# 616 "pio.F90.in"
  integer function put_att_desc_real (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    real(r4), intent(in)      :: value

    ierr = 0
# 623 "pio.F90.in"
  end function put_att_desc_real
# 616 "pio.F90.in"
  integer function put_att_desc_double (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    real(r8), intent(in)      :: value

    ierr = 0
# 623 "pio.F90.in"
  end function put_att_desc_double
# 616 "pio.F90.in"
  integer function put_att_desc_int (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    integer(i4), intent(in)      :: value

    ierr = 0
# 623 "pio.F90.in"
  end function put_att_desc_int

! TYPE real,int,double
# 626 "pio.F90.in"
  integer function put_att_desc_1d_real (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    real(r4), intent(in)      :: value(:)

    ierr = 0
# 633 "pio.F90.in"
  end function put_att_desc_1d_real
! TYPE real,int,double
# 626 "pio.F90.in"
  integer function put_att_desc_1d_int (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    integer(i4), intent(in)      :: value(:)

    ierr = 0
# 633 "pio.F90.in"
  end function put_att_desc_1d_int
! TYPE real,int,double
# 626 "pio.F90.in"
  integer function put_att_desc_1d_double (File,varDesc,name,value) result(ierr)
    type (File_desc_t), intent(inout) , target :: File
    type (VAR_desc_t), intent(in)     :: varDesc
    character(len=*), intent(in)      :: name
    real(r8), intent(in)      :: value(:)

    ierr = 0
# 633 "pio.F90.in"
  end function put_att_desc_1d_double
  
# 635 "pio.F90.in"
  integer function put_var1_text (File,varid, index, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, index(:)
    character(len=*), intent(in) :: ival

    ierr = 0
# 641 "pio.F90.in"
  end function put_var1_text

! TYPE int,real,double
# 644 "pio.F90.in"
  integer function put_var1_int (File,varid, index, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, index(:)
    integer(i4), intent(in) :: ival

    ierr = 0
# 650 "pio.F90.in"
  end function put_var1_int
! TYPE int,real,double
# 644 "pio.F90.in"
  integer function put_var1_real (File,varid, index, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, index(:)
    real(r4), intent(in) :: ival

    ierr = 0
# 650 "pio.F90.in"
  end function put_var1_real
! TYPE int,real,double
# 644 "pio.F90.in"
  integer function put_var1_double (File,varid, index, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, index(:)
    real(r8), intent(in) :: ival

    ierr = 0
# 650 "pio.F90.in"
  end function put_var1_double

# 652 "pio.F90.in"
  integer function put_var1_vdesc_text (File,vardesc, start, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:)
    character(len=*), intent(in) :: ival

    ierr = 0
# 659 "pio.F90.in"
  end function put_var1_vdesc_text
# 652 "pio.F90.in"
  integer function put_var1_vdesc_real (File,vardesc, start, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:)
    real(r4), intent(in) :: ival

    ierr = 0
# 659 "pio.F90.in"
  end function put_var1_vdesc_real
# 652 "pio.F90.in"
  integer function put_var1_vdesc_double (File,vardesc, start, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:)
    real(r8), intent(in) :: ival

    ierr = 0
# 659 "pio.F90.in"
  end function put_var1_vdesc_double
# 652 "pio.F90.in"
  integer function put_var1_vdesc_int (File,vardesc, start, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:)
    integer(i4), intent(in) :: ival

    ierr = 0
# 659 "pio.F90.in"
  end function put_var1_vdesc_int

! DIMS 0,1,2,3,4,5
! TYPE text
# 663 "pio.F90.in"
  integer function put_var_0d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: ival

    ierr = 0
# 669 "pio.F90.in"
  end function put_var_0d_text
! DIMS 0,1,2,3,4,5
! TYPE text
# 663 "pio.F90.in"
  integer function put_var_1d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: ival(:)

    ierr = 0
# 669 "pio.F90.in"
  end function put_var_1d_text
! DIMS 0,1,2,3,4,5
! TYPE text
# 663 "pio.F90.in"
  integer function put_var_2d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: ival(:,:)

    ierr = 0
# 669 "pio.F90.in"
  end function put_var_2d_text
! DIMS 0,1,2,3,4,5
! TYPE text
# 663 "pio.F90.in"
  integer function put_var_3d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: ival(:,:,:)

    ierr = 0
# 669 "pio.F90.in"
  end function put_var_3d_text
! DIMS 0,1,2,3,4,5
! TYPE text
# 663 "pio.F90.in"
  integer function put_var_4d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 669 "pio.F90.in"
  end function put_var_4d_text
! DIMS 0,1,2,3,4,5
! TYPE text
# 663 "pio.F90.in"
  integer function put_var_5d_text (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    character(len=*), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 669 "pio.F90.in"
  end function put_var_5d_text

! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_1d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    integer(i4), intent(in) :: ival(:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_1d_int
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_2d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    integer(i4), intent(in) :: ival(:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_2d_int
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_3d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    integer(i4), intent(in) :: ival(:,:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_3d_int
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_4d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    integer(i4), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_4d_int
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_5d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    integer(i4), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_5d_int
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_1d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r4), intent(in) :: ival(:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_1d_real
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_2d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r4), intent(in) :: ival(:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_2d_real
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_3d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r4), intent(in) :: ival(:,:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_3d_real
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_4d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r4), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_4d_real
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_5d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r4), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_5d_real
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_1d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r8), intent(in) :: ival(:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_1d_double
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_2d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r8), intent(in) :: ival(:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_2d_double
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_3d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r8), intent(in) :: ival(:,:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_3d_double
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_4d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r8), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_4d_double
! DIMS 1,2,3,4,5
! TYPE int,real,double
# 673 "pio.F90.in"
  integer function put_var_5d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r8), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 679 "pio.F90.in"
  end function put_var_5d_double

! TYPE int,real,double
# 682 "pio.F90.in"
  integer function put_var_0d_int (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    integer(i4), intent(in) :: ival

    ierr = 0
# 688 "pio.F90.in"
  end function put_var_0d_int
! TYPE int,real,double
# 682 "pio.F90.in"
  integer function put_var_0d_real (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r4), intent(in) :: ival

    ierr = 0
# 688 "pio.F90.in"
  end function put_var_0d_real
! TYPE int,real,double
# 682 "pio.F90.in"
  integer function put_var_0d_double (File,varid, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid
    real(r8), intent(in) :: ival

    ierr = 0
# 688 "pio.F90.in"
  end function put_var_0d_double

! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_0d_text (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    character(len=*), intent(in) :: ival

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_0d_text
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_1d_text (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    character(len=*), intent(in) :: ival(:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_1d_text
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_2d_text (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    character(len=*), intent(in) :: ival(:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_2d_text
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_3d_text (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    character(len=*), intent(in) :: ival(:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_3d_text
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_4d_text (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    character(len=*), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_4d_text
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_5d_text (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    character(len=*), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_5d_text
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_0d_real (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r4), intent(in) :: ival

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_0d_real
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_1d_real (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r4), intent(in) :: ival(:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_1d_real
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_2d_real (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r4), intent(in) :: ival(:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_2d_real
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_3d_real (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r4), intent(in) :: ival(:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_3d_real
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_4d_real (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r4), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_4d_real
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_5d_real (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r4), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_5d_real
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_0d_double (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r8), intent(in) :: ival

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_0d_double
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_1d_double (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r8), intent(in) :: ival(:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_1d_double
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_2d_double (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r8), intent(in) :: ival(:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_2d_double
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_3d_double (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r8), intent(in) :: ival(:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_3d_double
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_4d_double (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r8), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_4d_double
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_5d_double (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    real(r8), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_5d_double
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_0d_int (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    integer(i4), intent(in) :: ival

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_0d_int
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_1d_int (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    integer(i4), intent(in) :: ival(:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_1d_int
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_2d_int (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    integer(i4), intent(in) :: ival(:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_2d_int
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_3d_int (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    integer(i4), intent(in) :: ival(:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_3d_int
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_4d_int (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    integer(i4), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_4d_int
! DIMS 0,1,2,3,4,5
# 691 "pio.F90.in"
  integer function put_var_vdesc_5d_int (File, vardesc, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t) , intent(in) :: vardesc
    integer(i4), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 697 "pio.F90.in"
  end function put_var_vdesc_5d_int

! DIMS 1,2,3,4,5
! TYPE text
# 701 "pio.F90.in"
  integer function put_vara_1d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(in) :: ival(:)

    ierr = 0
# 707 "pio.F90.in"
  end function put_vara_1d_text
! DIMS 1,2,3,4,5
! TYPE text
# 701 "pio.F90.in"
  integer function put_vara_2d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(in) :: ival(:,:)

    ierr = 0
# 707 "pio.F90.in"
  end function put_vara_2d_text
! DIMS 1,2,3,4,5
! TYPE text
# 701 "pio.F90.in"
  integer function put_vara_3d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(in) :: ival(:,:,:)

    ierr = 0
# 707 "pio.F90.in"
  end function put_vara_3d_text
! DIMS 1,2,3,4,5
! TYPE text
# 701 "pio.F90.in"
  integer function put_vara_4d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 707 "pio.F90.in"
  end function put_vara_4d_text
! DIMS 1,2,3,4,5
! TYPE text
# 701 "pio.F90.in"
  integer function put_vara_5d_text (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    character(len=*), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 707 "pio.F90.in"
  end function put_vara_5d_text
  
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_1d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(in) :: ival(:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_1d_int
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_2d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(in) :: ival(:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_2d_int
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_3d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(in) :: ival(:,:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_3d_int
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_4d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_4d_int
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_5d_int (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    integer(i4), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_5d_int
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_1d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(in) :: ival(:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_1d_real
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_2d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(in) :: ival(:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_2d_real
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_3d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(in) :: ival(:,:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_3d_real
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_4d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_4d_real
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_5d_real (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r4), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_5d_real
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_1d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(in) :: ival(:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_1d_double
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_2d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(in) :: ival(:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_2d_double
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_3d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(in) :: ival(:,:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_3d_double
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_4d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_4d_double
! TYPE int,real,double
! DIMS 1,2,3,4,5
# 711 "pio.F90.in"
  integer function put_vara_5d_double (File,varid, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    integer, intent(in) :: varid, start(:), count(:)
    real(r8), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 717 "pio.F90.in"
  end function put_vara_5d_double

! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_1d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    character(len=*), intent(in) :: ival(:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_1d_text
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_2d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    character(len=*), intent(in) :: ival(:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_2d_text
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_3d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    character(len=*), intent(in) :: ival(:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_3d_text
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_4d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    character(len=*), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_4d_text
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_5d_text (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    character(len=*), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_5d_text
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_1d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r4), intent(in) :: ival(:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_1d_real
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_2d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r4), intent(in) :: ival(:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_2d_real
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_3d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r4), intent(in) :: ival(:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_3d_real
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_4d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r4), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_4d_real
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_5d_real (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r4), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_5d_real
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_1d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r8), intent(in) :: ival(:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_1d_double
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_2d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r8), intent(in) :: ival(:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_2d_double
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_3d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r8), intent(in) :: ival(:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_3d_double
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_4d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r8), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_4d_double
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_5d_double (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    real(r8), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_5d_double
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_1d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    integer(i4), intent(in) :: ival(:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_1d_int
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_2d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    integer(i4), intent(in) :: ival(:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_2d_int
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_3d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    integer(i4), intent(in) :: ival(:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_3d_int
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_4d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    integer(i4), intent(in) :: ival(:,:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_4d_int
! DIMS 1,2,3,4,5
# 720 "pio.F90.in"
  integer function put_vara_vdesc_5d_int (File,vardesc, start, count, ival) result(ierr)
    type (File_desc_t), intent(inout) :: File
    type(var_desc_t), intent(in) :: vardesc
    integer, intent(in) ::  start(:), count(:)
    integer(i4), intent(in) :: ival(:,:,:,:,:)

    ierr = 0
# 727 "pio.F90.in"
  end function put_vara_vdesc_5d_int

! TYPE real,int,double
# 730 "pio.F90.in"
  subroutine read_darray_1d_real (File,varDesc, ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r4), dimension(:), intent(inout) ::  &
	 array                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 746 "pio.F90.in"
  end subroutine read_darray_1d_real
! TYPE real,int,double
# 730 "pio.F90.in"
  subroutine read_darray_1d_int (File,varDesc, ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    integer(i4), dimension(:), intent(inout) ::  &
	 array                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 746 "pio.F90.in"
  end subroutine read_darray_1d_int
! TYPE real,int,double
# 730 "pio.F90.in"
  subroutine read_darray_1d_double (File,varDesc, ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r8), dimension(:), intent(inout) ::  &
	 array                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 746 "pio.F90.in"
  end subroutine read_darray_1d_double

! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_2d_real (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r4), intent(inout) ::  array(:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_2d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_3d_real (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r4), intent(inout) ::  array(:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_3d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_4d_real (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r4), intent(inout) ::  array(:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_4d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_5d_real (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r4), intent(inout) ::  array(:,:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_5d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_6d_real (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r4), intent(inout) ::  array(:,:,:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_6d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_7d_real (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r4), intent(inout) ::  array(:,:,:,:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_7d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_2d_int (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    integer(i4), intent(inout) ::  array(:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_2d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_3d_int (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    integer(i4), intent(inout) ::  array(:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_3d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_4d_int (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    integer(i4), intent(inout) ::  array(:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_4d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_5d_int (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    integer(i4), intent(inout) ::  array(:,:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_5d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_6d_int (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    integer(i4), intent(inout) ::  array(:,:,:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_6d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_7d_int (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    integer(i4), intent(inout) ::  array(:,:,:,:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_7d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_2d_double (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r8), intent(inout) ::  array(:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_2d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_3d_double (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r8), intent(inout) ::  array(:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_3d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_4d_double (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r8), intent(inout) ::  array(:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_4d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_5d_double (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r8), intent(inout) ::  array(:,:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_5d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_6d_double (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r8), intent(inout) ::  array(:,:,:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_6d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 750 "pio.F90.in"
  subroutine read_darray_7d_double (File,varDesc,ioDesc, array, iostat)
    type (File_desc_t), intent(inout) :: &
	 File                   ! file information

    type (var_desc_t), intent(inout) :: &
	 varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
	 ioDesc                      ! iodecomp descriptor

    real(r8), intent(inout) ::  array(:,:,:,:,:,:,:)                 ! array to be read

    integer(i4), intent(out) :: iostat

    iostat = 0
# 765 "pio.F90.in"
  end subroutine read_darray_7d_double
    
# 767 "pio.F90.in"
  subroutine setdebuglevel(level)
    integer(i4), intent(in) :: level	
# 769 "pio.F90.in"
  end subroutine setdebuglevel

# 771 "pio.F90.in"
  subroutine seterrorhandlingf(file, method)
    type(file_desc_t), intent(inout) :: file
    integer, intent(in) :: method
# 774 "pio.F90.in"
  end subroutine seterrorhandlingf

# 776 "pio.F90.in"
  subroutine seterrorhandlingi(ios, method)
    type(iosystem_desc_t), intent(inout) :: ios
    integer, intent(in) :: method
# 779 "pio.F90.in"
  end subroutine seterrorhandlingi
    
! TYPE real,int,double
# 782 "pio.F90.in"
  subroutine write_darray_1d_real (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r4), dimension(:), target, intent(in) ::  &
         array                 ! array to be written

    real(r4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 800 "pio.F90.in"
  end subroutine write_darray_1d_real
! TYPE real,int,double
# 782 "pio.F90.in"
  subroutine write_darray_1d_int (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    integer(i4), dimension(:), target, intent(in) ::  &
         array                 ! array to be written

    integer(i4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 800 "pio.F90.in"
  end subroutine write_darray_1d_int
! TYPE real,int,double
# 782 "pio.F90.in"
  subroutine write_darray_1d_double (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r8), dimension(:), target, intent(in) ::  &
         array                 ! array to be written

    real(r8), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 800 "pio.F90.in"
  end subroutine write_darray_1d_double

! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_2d_real (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r4), intent(in) ::  &
         array(:,:)                 ! array to be written

    real(r4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_2d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_3d_real (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r4), intent(in) ::  &
         array(:,:,:)                 ! array to be written

    real(r4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_3d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_4d_real (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r4), intent(in) ::  &
         array(:,:,:,:)                 ! array to be written

    real(r4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_4d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_5d_real (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r4), intent(in) ::  &
         array(:,:,:,:,:)                 ! array to be written

    real(r4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_5d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_6d_real (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r4), intent(in) ::  &
         array(:,:,:,:,:,:)                 ! array to be written

    real(r4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_6d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_7d_real (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r4), intent(in) ::  &
         array(:,:,:,:,:,:,:)                 ! array to be written

    real(r4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_7d_real
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_2d_int (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    integer(i4), intent(in) ::  &
         array(:,:)                 ! array to be written

    integer(i4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_2d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_3d_int (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    integer(i4), intent(in) ::  &
         array(:,:,:)                 ! array to be written

    integer(i4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_3d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_4d_int (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    integer(i4), intent(in) ::  &
         array(:,:,:,:)                 ! array to be written

    integer(i4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_4d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_5d_int (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    integer(i4), intent(in) ::  &
         array(:,:,:,:,:)                 ! array to be written

    integer(i4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_5d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_6d_int (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    integer(i4), intent(in) ::  &
         array(:,:,:,:,:,:)                 ! array to be written

    integer(i4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_6d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_7d_int (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    integer(i4), intent(in) ::  &
         array(:,:,:,:,:,:,:)                 ! array to be written

    integer(i4), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_7d_int
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_2d_double (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r8), intent(in) ::  &
         array(:,:)                 ! array to be written

    real(r8), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_2d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_3d_double (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r8), intent(in) ::  &
         array(:,:,:)                 ! array to be written

    real(r8), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_3d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_4d_double (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r8), intent(in) ::  &
         array(:,:,:,:)                 ! array to be written

    real(r8), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_4d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_5d_double (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r8), intent(in) ::  &
         array(:,:,:,:,:)                 ! array to be written

    real(r8), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_5d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_6d_double (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r8), intent(in) ::  &
         array(:,:,:,:,:,:)                 ! array to be written

    real(r8), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_6d_double
! TYPE real,int,double
! DIMS 2,3,4,5,6,7
# 804 "pio.F90.in"
  subroutine write_darray_7d_double (File,varDesc,ioDesc, array, iostat, fillval)
    type (File_desc_t), intent(inout) :: &
         File                   ! file information

    type (var_desc_t), intent(inout) :: &
         varDesc                      ! variable descriptor

    type (io_desc_t), intent(inout) :: &
         ioDesc                      ! variable descriptor

    real(r8), intent(in) ::  &
         array(:,:,:,:,:,:,:)                 ! array to be written

    real(r8), optional, intent(in) :: fillval    ! rearrange receiver fill value

    integer(i4), intent(out) :: iostat

    iostat = 0
# 822 "pio.F90.in"
  end subroutine write_darray_7d_double
  
end module pio
